<?php
/**
 * @package heiv-gallery_3
 * @author www.heiv.fr 
 * @version 0.1.1
 */
/*
Plugin Name: heiv Gallery 3
Plugin URI: http://www.heiv.fr/wordpress/plugin/gallery3
Description: heiv-gallery_3 is a Wordpress Plug-in that embeds Gallery3 within Wordpress to share photos, videos and any other Gallery3 content seamlessly into the Wordpress Sidebar and Blog entries.
Version: 0.1.0
Author: heiv
Author URI: http://www.heiv.fr
License: GPL3

  Copyright 2010 heiv  (email: moi@heiv.fr )

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 3, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*
if ( ! defined( 'ABSPATH' ) ) 
        die( "Can't load this file directly" );
*/

class heiv_gallery_3 {
	private $pattern_css_photo = '
		<script type="text/javascript">
			function startGallery_%1$s() {
				$(\'%1$s\').style.height=\'%2$s\';
				$(\'%1$s\').style.width=\'%3$s\';
			}
			window.addEvent(\'domready\', startGallery_%1s);
		</script>';
	private $pattern_js_gallery= '
		<script type="text/javascript">
			function startGallery_%1$s() {
				var myGallery = new gallery($(\'%1$s\'), {
					timed: false
				});
				$(\'%1$s\').style.height=\'%2$s\';
				$(\'%1$s\').style.width=\'%3$s\';
			}
			window.addEvent(\'domready\', startGallery_%1s);
		</script>';        

	function __construct() {
		add_action( 'admin_init', array( $this, 'action_admin_init' ) );
		add_action( 'init', array( $this, 'action_init' ) );
		add_action('wp_head',array($this, 'header_init_css') );
		add_action('admin_menu',array($this,'config_admin_menu') );
		add_action('wp_ajax_heiv_gallery_3_populate_tree', array($this,'ajax_hg3_populate_tree_cb') );
		add_action('wp_ajax_heiv_gallery_3_test_config', array($this,'ajax_hg3_test_config_cb') );
		add_shortcode('hgallery3',array($this,'hg3_display') );
	}

        function action_init() {
		// pas d'inclusion de mootools et de jd.gallery si on est en mode BE
		if(!strstr($_SERVER['REQUEST_URI'],'wp-admin')) {
			wp_deregister_script( 'mootools' );
			wp_register_script( 'mootools', plugin_dir_url(__FILE__) . 'js/mootools.v1.11.js');
			wp_enqueue_script('mootools');
			
			wp_deregister_script( 'jd_gallery' );
			wp_register_script( 'jd_gallery', plugin_dir_url(__FILE__) . 'js/jd.gallery.js',array('mootools'));
			wp_enqueue_script('jd_gallery');
		}
	}

	function header_init_css(){
		echo '<link type="text/css" rel="stylesheet" href="' . plugin_dir_url(__FILE__) . 'css/jd.gallery.css" />';
	}

        function action_admin_init() {
        // only hook up these filters if we're in the admin panel, and the current user has permission
        	if ( current_user_can( 'edit_posts' ) || current_user_can( 'edit_pages' ) ) {
			add_filter( 'mce_buttons', array($this,'filter_mce_button') );
			add_filter( 'mce_external_plugins', array($this,'filter_mce_plugin') );
			wp_enqueue_script( 'json2' );
		}
	 } 

	function config_admin_menu(){
		add_options_page('Gallery 3 Configuration','Gallery 3',9,basename(__FILE__),array($this,'admin_config_page') );
	}

	function filter_mce_button( $buttons ) {
		// add a separation before our button, here our button's id is &quot;mygallery_button&quot;
		array_push( $buttons, '|', 'heiv_gallery_3_button' );
		return $buttons;
	}

	function filter_mce_plugin( $plugins ) {
		// this plugin file will work the magic of our button
		$plugins['heiv_gallery_3'] = plugin_dir_url( __FILE__ ) . 'heiv_gallery_3_mce_editor.js';
		return $plugins;
	}
	
	function admin_config_page(){
		if ( isset($_POST['submit']) ) {
			if (!current_user_can('manage_options')) 
				die(__('You cannot edit the Gallery 3 options.'));
			$options = array();

			if (isset($_POST['g3_baseurl']) && $_POST['g3_baseurl'] != "")
				$options['g3_baseurl'] = strtolower($_POST['g3_baseurl']);

			if (isset($_POST['g3_host']) && $_POST['g3_host'] != "")
				$options['g3_host']  = strtolower($_POST['g3_host']);

			if (isset($_POST['g3_baserest']) && $_POST['g3_baserest'] != "")
				$options['g3_baserest'] = strtolower($_POST['g3_baserest']);

			if ( isset($_POST['g3_height']) && $_POST['g3_height'] != '' )
				$options['g3_height'] = intval($_POST['g3_height']);
			else
				$options['g3_height'] = 300 ;
			
			if ( isset($_POST['g3_width']) && $_POST['g3_width'] != '' )
				$options['g3_width'] = intval($_POST['g3_width']);
			else
				$options['g3_width'] = 200;

			if (isset($_POST['g3_directlink'])) {
				$options['g3_directlink'] = true;
			} else {
				$options['g3_directlink'] = false;
			}
			
			if (isset($_POST['g3_target'])) {
				$options['g3_target'] = $_POST['g3_target'];
			} else {
				$options['g3_target'] = '_blank';
			}

			update_option('HeiVGallery3PP', $options);
		}
		$options = get_option('HeivGallery3PP');
	?>
		<div class="wrap">
			<script type="text/javascript">
				function help(ele1, ele2) {
					var expl = document.getElementById(ele2);
					if (expl.style.display == "block") {
						expl.style.display = "none";
						ele1.innerHTML = "(help)";
					} else {
						expl.style.display = "block";
						ele1.innerHTML = "(Hide help)";
					}
				}
				function test_config_gallery3(){
					var host = jQuery('#g3_host').val();
					if(!host)
						host = '';
					var uri_base=jQuery('#g3_baseurl').val();
					if(!uri_base)
						uri_base='';
					var uri_rest=jQuery('#g3_baserest').val();
					if(!uri_rest)
						uri_rest='';
					
					var data = { 
						host:host,
						uri_base:uri_base,
						uri_rest:uri_rest,
						action: 'heiv_gallery_3_test_config'
					};
					jQuery.post(ajaxurl, data, function(response) {
						alert(response);
					});
				}
			</script>

			<h2>Gallery 3 Configuration</h2>
			<form action="" method="post" id="heiv_g3_conf">
				<table class="form-table" style="width:100%;">
					<tr>
						<td style="width:30%;">
							<label for="g3_host">Hostname of the Gallery 3 installation</label><br/><small><a href="#" onclick="javascript:help(this, 'help_host');">(help)</a></small>
						</td>
						<td style="width:70%;">
							<input name="g3_host" id="g3_host" type="text" value="<?php echo $options['g3_host'];?>" maxlength="99" size="40"/>
						</td>
					</tr>
					<tr id="help_host" style="display:none;border:1px solid grey;">
						<td colspan="2">
							address where you have set up a Gallery3 site
						</td>
					</tr>
					<tr>
						<td>
							<label for="g3_baseurl">Base URL of Gallery 3</label><br/><small><a href="#" onclick="javascript:help(this, 'help_baseurl');">(help)</a></small>
						</td>
						<td>
							<input name="g3_baseurl" id="g3_baseurl" type="text" value="<?php echo $options['g3_baseurl']; ?>" maxlength="99" size="40"/>
						</td>
					</tr>
					<tr id="help_baseurl" style="display:none;border:1px solid grey;"> 
						<td colspan="2">
							by default it is "/index.php"
						</td>
					</tr>
					<tr>
						<td>
							<label for="g3_baserest">Base URL of the restful acces of Gallery 3</label><br/><small><a href="#" onclick="javascript:help(this, 'help_baserest');">(help)</a></small>
						</td>
						<td>
							<input name="g3_baserest" id="g3_baserest" type="text" value="<?php echo $options['g3_baserest']; ?>" maxlength="99" size="40"/>
						</td>
					</tr>
					<tr id="help_baserest" style="display:none;border:1px solid grey;"> 
						<td colspan="2">
							by default it is "/index/rest/item"
						</td>
					</tr>
					<tr>
						<td>
							<label for="g3_height">Default height</label><br/><small><a href="#" onclick="javascript:help(this, 'help_height');">(help)</a></small>
						</td>
						<td>
							<input name="g3_height" id="g3_height" type="text" value="<?php echo $options['g3_height']; ?>" maxlength="99" size="40"/>
						</td>
					</tr>
					<tr id="help_height" style="display:none;border:1px solid grey;"> 
						<td colspan="2">
							bla bla
						</td>
					</tr>
					<tr>
						<td>
							<label for="g3_width">Default width</label><br/><small><a href="#" onclick="javascript:help(this, 'help_width');">(help)</a></small>
						</td>
						<td>
							<input name="g3_width" id="g3_width" type="text" value="<?php echo $options['g3_width']; ?>" maxlength="99" size="40"/>
						</td>
					</tr>
					<tr id="help_width" style="display:none;border:1px solid grey;"> 
						<td colspan="2">
							the height by default for display a picture or a album (in pixel(px))
						</td>
					</tr>
	<!-- futur feature
					<tr>
						<td>
							<label for="g3_curl">Use CURL</label><br/><small><a href="#" onclick="javascript:help(this, 'help_curl');">(help)</a></small>
						</td>
						<td>
							<input name="g3_curl" id="g3_curl" type="text" value="<?php echo $options['g3_curl']; ?>" maxlength="99" size="40"/>
						</td>
					</tr>
	-->
					<tr id="help_curl" style="display:none;border:1px solid grey;"> 
						<td colspan="2">
							the width by default for display a picture or a album (in pixel (px))
						</td>
					</tr>
					<tr>
						<td>
							<label for="g3_directlink">Direct link to gallerys / pictures</label><br/><small><a href="#" onclick="javascript:help(this, 'help_directlink');">(help)</a></small>
						</td>
						<td>
							<input type="checkbox" id="g3_directlink" name="g3_directlink" <?php if ($options['g3_directlink']) echo ' checked="unchecked" '; ?>/>
						</td>
					</tr>
					<tr id="help_directlink" style="display:none;border:1px solid grey;"> 
						<td colspan="2">
							option which allow a visitor to go on the Gallery3 site
						</td>
					</tr>
					<tr>
						<td>
							<label for="g3_target">Direct link to gallerys / pictures</label><br/><small><a href="#" onclick="javascript:help(this, 'help_target');">(help)</a></small>
						</td>
						<td>
							<select id="g3_target" name="g3_target">
								<option <?php if ($options['g3_target']=='_blank') echo 'selected="selected"'; ?> value="_blank">_blank</option>
								<option <?php if ($options['g3_target']=='_parent') echo 'selected="selected"'; ?> value="_parent">_parent</option>
								<option <?php if ($options['g3_target']=='_self') echo 'selected="selected"'; ?> value="_self">_self</option>
							</select> 
						</td>
					</tr>
					<tr id="help_target" style="display:none;border:1px solid grey;"> 
						<td colspan="2">
							open picture or album Gallery3 site :

<br/>    * _self => in the current page
<br/>    * _parent => in the parent page of the current page
<br/>    * _blank => in a new page

						</td>
					</tr>
				</table>
				<p style="border:0;" class="submit"><input type="button" name="test" value="Test Settings &raquo;" onclick="test_config_gallery3()"/>
				<input type="submit" name="submit" value="Update Settings &raquo;" /></p>
			</form>
		</div>

	<?php
	}
	
	function get_infos($url) {
		$ret=null;
		if($url){
			$handle = fopen($url,'rb');
			$contents = '';
			if($handle){
				$contents = utf8_encode(stream_get_contents($handle));
				fclose($handle);
				if($contents){
					$ret = json_decode($contents);
				}
			}
		}
		return $ret;
	}

	function get_direct_link($url) {
		$link = '';
		if($url) {
			$continue=true;
			do {
				$info = $this->get_infos($url);
				if($info!=null && isset($info->entity->parent) ) {
					$link = '/' . $info->entity->slug . $link;
					$url = $info->entity->parent;
					$info=null;
				}
				else{
					$continue=false;
				}
			} while( $continue ) ;
		}
		return  $link;
	}

	function test_url($url) {
		$ret = false;
		$allow_url_fopen = ini_get('allow_url_fopen');
		if($allow_url_fopen){
			if($url!=''){
				try {
					$handle = fopen($url,'rb');
					if($handle!==FALSE){
						$bytes = fread($handle,2048);
						if($bytes!==FALSE){
							$ret = true;
						}
					}
				}
				catch (Exception $e){
					$ret = false;
				}
			}
		}
		return $ret;
	}

	function ajax_hg3_test_config_cb() {
		$host='';
		$uri_base='';
		$uri_rest='';
		$ret = '';
		if(isset($_POST['host']) && $_POST['host']!='') {
			$host = $_POST['host'];
			if($this->test_url($host)) {
				if(isset($_POST['uri_base']) && $_POST['uri_base']!='') {
					$uri_base = $_POST['uri_base'];
					if(!$this->test_url($host.$uri_base)) {
						$ret = 'Error : ' . $host . $uri_base . " is not accessible.\n";
					}
				}
				if(isset($_POST['uri_rest']) && $_POST['uri_rest']!='') {
					$uri_rest = $_POST['uri_rest'];
					if(!$this->test_url($host.$uri_rest.'/1')) {
						if($ret=='')
							$ret='Error :';
						$ret .= $host . $uri_rest . " is not accessible.\n";
					}
				}
				if($ret=='')
					$ret='Configuration ok';
			}
			else {
				$ret = 'Error : ' . $host . ' is not accessible';
			}
		}
		else {
			$ret = 'The value of "Host" is empty';
		}
		echo $ret;
		die();
	}

	function ajax_hg3_populate_tree_cb() {
		$options = get_option('HeivGallery3PP');
		extract(shortcode_atts(array(
			'host'=>$options['g3_host'],
			'base_url' => $options['g3_baseurl'],
			'base_rest' => $options['g3_baserest'],
			'url_base'=>sprintf('%s%s',$options['g3_host'],$options['g3_baseurl']),
			'target'=>'_blank',
			'id' => '1',
			'width' => $options['g3_width'],
			'height' => $options['g3_height'],
			'direct_link' => 'none',
			'limit' => 15,
			'start' => 0
		), $attrs));

		if(isset($_POST['id']) && $_POST['id']!='')
			$id = $_POST['id'];
		if(isset($_POST['limit']) && $_POST['limit']!='')
			$limit = $_POST['limit'];
		if(isset($_POST['start']) && $_POST['start']!='')
			$start = $_POST['start'];
		
		$url_base = sprintf('%s%s',$host,$base_url);
		$url = sprintf('%s%s/%d',$host,$base_rest,$id);

		$info = $this->get_infos($url);
		$ret = array();
		if($info){
			$ret['title'] = $info->entity->title;
			$ret['members'] = array();
			$ret['req'] = $id;
			$nb_photos = 0;
			$start_ = $start*$limit;
			$stop = ($start+1)*$limit;
			foreach($info->members as $member){
				$info_tmp = $this->get_infos($member);
				if($info_tmp){
					switch($info_tmp->entity->type){
						case 'album':
							array_push(
								$ret['members'],	array(	'id' 	=> $info_tmp->entity->id,
												'title' => $info_tmp->entity->name,
												'type'	=> $info_tmp->entity->type,
												'thumb'	=> $info_tmp->entity->thumb_url)
							);
						break;
						case 'photo':
							if($start_ <= $nb_photos && $nb_photos <$stop){
								array_push(
									$ret['members'],	array(	'id' 	=> $info_tmp->entity->id,
													'title' => $info_tmp->entity->name,
													'type'	=> $info_tmp->entity->type,
													'thumb'	=> $info_tmp->entity->thumb_url)
								);
							}
							$nb_photos++;
						break;
					}
				}
			}
			$ret['nb_photos'] = $nb_photos;
			$ret['nb_pages'] = ceil($nb_photos/$limit);
			$ret['pid'] = substr(strrchr($info->entity->parent, '/'), 1);
			$ret['req_p'] = $start;
		}
		else {
			$ret['error']=1;
		}
		$ret = json_encode($ret);
		echo $ret;
		die(); // it is normal to die here for ajax mode
	}
	
	function get_render_album($id,$title,$description,$url_img,$url_direct) {
		return sprintf('
			<div class="imageElement" id="%s">
				<h3>&nbsp;%s</h3>
				<p>%s</p>
				<a href="%s" title="open image" class="open">&nbsp;</a>
				<img src="%s" class="thumbnail" alt="&nbsp;"/>
				<img src="%s" class="full" alt="&nbsp;"/>
			</div>',$id,$title,$description,$url_direct,$url_img,$url_img
		);
	}

	function get_render_photo($title,$description,$url_img,$url_thumb_img,$url_direct) {
		$thumb = $url_thumb_img!=''?sprintf('<img src="%s" class="thumbnail"/>',$url_thumb_img):'';
		$link = sprintf('<a href="%s" class="open"/>',($url_direct==''?'#':$url_direct));
		return sprintf('
			<div class="imageElement">
				<h3>%s</h3>
				<p>&nbsp;%s</p>
				<a href="%s" title="open image" class="open">&nbsp;</a>
				<img src="%s" class="full" />
				%s
			</div>
			',$title,$description,$url_direct,$url_img,$thumb
		);
	}


	function hg3_display($attrs,$content,$code) {
		$options = get_option('HeivGallery3PP');
		extract(shortcode_atts(array(
			'host'=>$options['g3_host'],
			'base_url' => $options['g3_baseurl'],
			'base_rest' => $options['g3_baserest'],
			'url_base'=>sprintf('%s%s',$options['g3_host'],$options['g3_baseurl']),
			'target'=>'_blank',
			'id' => '1',
			'width' => $options['g3_width'],
			'height' => $options['g3_height'],
			'direct_link' => 'none'
		), $attrs));

		if($direct_link=='none') {
			$direct_link = isset($options['g3_directlink'])&&$options['g3_directlink']==1;
		}
		else {
			$direct_link = $direct_link=='true';
		}
		
		if(is_numeric($height)){
			$height.='px';
		}
		else {
			$height = $options['g3_height'].'px';
		}

		if(is_numeric($width)){
			$width.='px';
		}
		else {
			$width = $options['g3_width'].'px';
		}

		$str = '';
		$str_css='';

		$url_base = sprintf('%s%s',$host,$base_url);
		$url = sprintf('%s%s/%d',$host,$base_rest,$id);
		$nomtime=function_exists(microtime);
		$rdm_id = sprintf('%.6s',md5(($nomtime?microtime():time()).rand(0,100)));
		
		$infos = $this->get_infos($url);
		if($infos){
			switch($infos->entity->type){
				case 'album':
					if(sizeof($infos->members)>1 ){
						foreach($infos->members as $member){
							$info = $this->get_infos($member);
							if($info){
								$url_direct = $direct_link ? $url_base.$this->get_direct_link($info->url):'#';
								if($info->entity->type=='album') {
									$str .= $this->get_render_album(	$info->entity->id,
													$info->entity->title,
													$info->entity->description,
													$info->entity->thumb_url,
													$url_direct
												);
								}
								elseif($info->entity->type=='photo') {
									$str .= $this->get_render_photo(	$info->entity->title,
													$info->entity->description,
													$info->entity->resize_url,
													$info->entity->thumb_url,
													$url_direct
												);
								}
							}
						}
						$str_css .= sprintf($this->pattern_js_gallery,'gallery_'.$rdm_id,$height,$width);
					}
					elseif (sizeof($infos->members)==1) {
						$info = $this->get_infos($infos->members[0]);
						if($info){
							$str_css = sprintf($this->pattern_css_photo,'gallery_'.$rdm_id,$height,$width);
							$url_direct = $direct_link ? $url_base.$this->get_direct_link($info->url):'#';
							$str .= $this->get_render_photo(	$info->entity->title,
											$info->entity->description . ' ' ,
											$info->entity->resize_url,
											'',
											$url_direct
										);
						}
					}
					else {
						$str = 'Gallerie vide';
					}
					break;
				case 'photo':
					$str_css = sprintf($this->pattern_css_photo,'gallery_'.$rdm_id.'_img',$height,$width);
					$str_img = sprintf('<img src="%s" id="%s_img"/>',$infos->entity->resize_url,'gallery_'.$rdm_id);
					if($direct_link){
						$url_direct = $direct_link ? $url_base . $this->get_direct_link($infos->url):'#';
						$str = sprintf('<a href="%s" title="%s" target="%s">%s</a>',$url_direct,$infos->entity->title,$options['g3_target'],$str_img);
					}
					else {
						$str = $str_img;
					}
					break;
			}
			$str = sprintf('%s<div id="gallery_%s">%s</div>',$str_css,$rdm_id,$str);
		}
		return $str;
	}
	};

$g3 = new heiv_gallery_3();

?>
