
/**
 * @package heiv-gallery_3
 * @author www.heiv.fr
 * @version 0.1.1
 */
/*
Plugin Name: heiv Gallery 3
Plugin URI: http://www.heiv.fr/wordpress/plugin/gallery3
Description: heiv-gallery_3 is a Wordpress Plug-in that embeds Gallery3 within Wordpress to share photos, videos and any other Gallery3 content seamlessly into the Wordpress Sidebar and Blog entries.
Version: 0.1.0
Author: heiv
Author URI: http://www.heiv.fr
License: GPL3

  Copyright 2010 heiv  (email: moi@heiv.fr )

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 3, as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
var CURRENT_ID=1;

// closure to avoid namespace collision
(function(){
	// creates the plugin
	tinymce.create('tinymce.plugins.heiv_gallery_3', {
		// creates control instances based on the control's id.
		// our button's id is &quot;mygallery_button&quot;
		createControl : function(id, controlManager) {
			if (id == 'heiv_gallery_3_button') {
				// creates the button
				var button = controlManager.createButton('heiv_gallery_3_button', {
					title : 'Ajouter une gallery3', // title of the button
					image : '../wp-includes/images/smilies/icon_mrgreen.gif',  // path to the button's image
					onclick : function() {

                                                var width = jQuery(window).width(), H = jQuery(window).height(), W = ( 720 < width ) ? 720 : width;
                                                W = W - 80;
                                                H = H - 84;
                                                tb_show( 'Gallery 3', '#TB_inline?width=' + W + '&height=' + H + '&inlineId=heiv_gallery_3_form' );
						populate_dir(1);
					}
				});
				return button;
			}
			return null;
		}
	});

	// registers the plugin. DON'T MISS THIS STEP!!!
	tinymce.PluginManager.add('heiv_gallery_3', tinymce.plugins.heiv_gallery_3);

        jQuery(function(){
                // creates a form to be displayed everytime the button is clicked
                // you should achieve this using AJAX instead of direct html code like this
                var form = jQuery('<div id="heiv_gallery_3_form"><table id="heiv_gallery_3_form_table" class="form-table">\
                        <tr>\
                                <th><label for="heiv_gallery_3_height">Height</label></th>\
                                <td><input type="text" id="heiv_gallery_3_height" name="height" value="" />px</td>\
                        </tr>\
                        <tr>\
                                <th><label for="heiv_gallery_3_width">Width</label></th>\
                                <td><input type="text" id="heiv_gallery_3_width" name="width" value="" />px</td>\
                        </tr>\
                        <tr>\
                                <th><label for="heiv_gallery_3_direct_link">Direct link ?</label></th>\
                                <td><input type="checkbox" id="heiv_gallery_3_direct_link" name="direct_link" /></td>\
                        </tr>\
                        <tr>\
                                <td><div id="heiv_gallery_3_tree"><ul id="node_1" style="border:1px solid grey;height:300px;overflow:auto;padding:5px;"></ul></div></td>\
				<td><select onchange="heiv_gallery_3_change_page()" id="heiv_gallery_3_listing_page"></select><div id="heiv_gallery_3_listing" style="border:1px solid grey;width:350px;height:284px;overflow:auto;"><ul id="heiv_gallery_3_listing_ul" style="text-align:center;margin-top:10px;"></ul></div></td>\
                        </tr>\
		</table>\
		<input type="submit" id="mygallery-submit"/>\
	</div>');
	        
		var table = form.find('table');
        	form.appendTo('body').hide();
                form.find('#mygallery-submit').click(function(){

			var id = jQuery('li.heiv_gallery_3_selected');
			if(id.length==1 && id[0].id!='node_1'){
				var options = {
					'height'	: '',
					'width'		: '',
					'direct_link'	: 'true'
				};
				var id = id[0].id;
                        	var shortcode = '[hgallery3 ';
				var error = false;
				var msg = '';
				shortcode += 'id="'+id.replace("node_","")+'"';

				for( var index in options) {
					var obj = table.find('#heiv_gallery_3_' + index);
					var value = table.find('#heiv_gallery_3_' + index).val();
					if ( value !== options[index] ){
						switch(index) {
							case 'direct_link':
								value = obj[0].checked;
							break;
							case 'height':
							case 'width':
								var exp = new RegExp("^[0-9]+$","g");
								if(!exp.test(value)) {
									msg += index + " is not a number\n";
									error = true;
								}
							break;
						}
						shortcode += ' ' + index + '="' + value + '"';
					}
				}
        	                shortcode += ']';

                        // inserts the shortcode into the active editor
				if(error)
					alert(msg);
				else {
	                	        tinyMCE.activeEditor.execCommand('mceInsertContent', 0, shortcode);
					tb_remove();
				}
			}
		});
	})
})()

function populate_dir(id) {
	var num_page = jQuery('#heiv_gallery_3_listing_page').val();
	if(num_page) {
//		num_page = new Number(num_page)-1
	}
	else {
		num_page=0;
	}
	var data = {
		action: 'heiv_gallery_3_populate_tree',
		start: num_page,
		id:id 
	};
	jQuery.post(ajaxurl, data, function(response) {
		var resp = JSON.parse(response);
		if(resp.error!=1){
			var root = jQuery('#node_1');
			root.html('');
			if(resp.req!=1){
				root.append('<li id="node_up"><a href="#" onclick="populate_dir('+resp.pid+')">..</a></li>');
			}
			var listing = jQuery('#heiv_gallery_3_listing_ul');
			listing.html('');
			var page = jQuery('#heiv_gallery_3_listing_page');
			page.html('');
			for(var i=1;i<=resp.nb_pages;i++) {
				page.append('<option value="'+(i-1)+'">page '+i+'</option>');
			}
			jQuery.each(resp.members, function (i,member){
				switch(member.type){
					case 'album':
						root.append('<li id="node_'+member.id+'"><a href="#" onclick="populate_dir('+member.id+',this)">'+member.title+'</a><a href="#" class="select" onclick="heiv_gallery_3_select('+member.id+',this)"> <-</a></li>');
					break;
					case 'photo':
						listing.append('<li id="node_'+member.id+'" id="node_'+member.id+'"><a href="#" onclick="heiv_gallery_3_select('+member.id+',this)"><img id="heiv_gallery_3_img_'+member.id+'" src="'+member.thumb+'"/></a></li><li><hr/></li>');
					break;
				}
				
			});
			page.val(resp.req_p);
			CURRENT_ID=resp.req;
//		alert('Got this from the server: ' + response);
		}
	});
}

function heiv_gallery_3_select(id,elem){
	jQuery('#node_1 li, #heiv_gallery_3_listing_ul li').css('background','none');
	jQuery('#node_1 li').removeClass('heiv_gallery_3_selected');
	jQuery('li#node_'+id).css('background','MistyRose');
	jQuery('li#node_'+id).addClass('heiv_gallery_3_selected');
}

function heiv_gallery_3_change_page(){
	var num_page = jQuery('#heiv_gallery_3_listing_page').val();
//	alert(num_page);
	populate_dir(CURRENT_ID);
}
